Read Time CodeForces - 343C (二分查找答案)

Mad scientist Mike does not use slow hard disks. His modification of a hard drive has not one, but n different heads that can read data in parallel.

When viewed from the side, Mike's hard drive is an endless array of tracks. The tracks of the array are numbered from left to right with integers, starting with 1. In the initial state the i-th reading head is above the track number hi. For each of the reading heads, the hard drive's firmware can move the head exactly one track to the right or to the left, or leave it on the current track. During the operation each head's movement does not affect the movement of the other heads: the heads can change their relative order; there can be multiple reading heads above any of the tracks. A track is considered read if at least one head has visited this track. In particular, all of the tracks numbered h1h2...hn have been read at the beginning of the operation.

Mike needs to read the data on m distinct tracks with numbers p1p2...pm. Determine the minimum time the hard drive firmware needs to move the heads and read all the given tracks. Note that an arbitrary number of other tracks can also be read.

Input

The first line of the input contains two space-separated integers nm (1 ≤ n, m ≤ 105) — the number of disk heads and the number of tracks to read, accordingly. The second line contains n distinct integers hi in ascending order (1 ≤ hi ≤ 1010hi < hi + 1) — the initial positions of the heads. The third line contains m distinct integers pi in ascending order (1 ≤ pi ≤ 1010pi < pi + 1) - the numbers of tracks to read.

Please, do not use the %lld specifier to read or write 64-bit integers in С++. It is recommended to use the cincout streams or the %I64d specifier.

Output

Print a single number — the minimum time required, in seconds, to read all the needed tracks.

Examples
Input
3 4
2 5 6
1 3 6 8
Output
2
Input
3 3
1 2 3
1 2 3
Output
0
Input
1 2
165
142 200
Output
81
Note

The first test coincides with the figure. In this case the given tracks can be read in 2 seconds in the following way:

  1. during the first second move the 1-st head to the left and let it stay there;
  2. move the second head to the left twice;
  3. move the third head to the right twice (note that the 6-th track has already been read at the beginning).

One cannot read the tracks in 1 second as the 3-rd head is at distance 2 from the 8-th track.


题意 :你有n个探头,m个触点,请问你用探头经过所有触点花费的最小时间

解:先把探头和触点 全部排下序  ,你二分找到1个时间 t , 显然在t时间内 我们 任何1个探头要做的工作是 要经过最左边未被经过的触点 而且尽可能到更右边

因为未被经过的最左端肯定是固定的而最右端则不固定 比如    最左端为 0    探头为  4    时间为  9   那么最右端有两种可能 1 .  先往左 在回来往右  到达 5       2.  先往  左再往右 能到达  6

#include<stdio.h>
#include<string.h>
#include<map>
#include<vector>
#include<iostream>
#include<algorithm>
#include<queue>
#include<deque>
#include<math.h>
#define ll long long
const ll inf=1e12;
using namespace std;
ll a[100005],b[100005];
int n,m;
int aa(ll x)
{
    ll o=0;
    for(int i=0;i<n;i++)
    {
        ll p=x;
        if(a[i]>=b[o])
        {
            if(x>=a[i]-b[o])
            {
                p=max((p-a[i]+b[o])/2,p-2*(a[i]-b[o]));//找到最右端
                if(p<0) p=0;
            }
            else
                return 0;
        }
        o=upper_bound(b,b+m,a[i]+p)-b;
        if(o>=m) return 1;
    }
    return 0;
}
int main()
{
    scanf("%d%d",&n,&m);
    for(int i=0;i<n;i++)
        scanf("%lld",&a[i]);
    for(int i=0;i<m;i++)
        scanf("%lld",&b[i]);
    sort(a,a+n);
    sort(b,b+m);
    ll l=0,r=inf,mid,ans;
    while(l<=r)
    {
         mid=(l+r)/2;
         if(aa(mid))
         {
             ans=mid;
             r=mid-1;
         }
         else
            l=mid+1;
    }
    printf("%lld\n",ans);
}




  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值